// C Header File
// Created 9/20/2002; 10:02:20 PM

#define NO_TARGETING_REAL_PLAYER 0
#define WAIT_AMOUNT 200

void AITurn (FATSPRITE * spr, short right, short increment);
void AIMove (FATCONFIG * fc, FATSPRITE * spr, short stepx, short stepy,
	     short newxpos, short newypos);

void
AI_DM_WALK (FATCONFIG * fc, short idx)
{
//TO DO: Make more interesting :-)
//Probably should turn sometimes if a player isn't seen
  short stepx;
  short stepy;
  short newxpos;
  short newypos;

  short a;
  short dx;
  short dy;
  long nx;

  //------------Simple movement stuff---------
  //Try to go in the facing direction
  stepx = FAT_Cos16384 (gamedata.player[idx].spr->orientation) >> 11;
  stepy = FAT_Sin16384 (gamedata.player[idx].spr->orientation) >> 11;
  newxpos = gamedata.player[idx].spr->xpos + stepx;
  newypos = gamedata.player[idx].spr->ypos + stepy;
  //If it doesn't work, turn until it does
  while (!ValidMove (fc, newxpos, newypos))
    {
      gamedata.player[idx].spr->orientation =
	FAT_ClampAngle (gamedata.player[idx].spr->orientation + ANGLE_015);
      stepx = FAT_Cos16384 (gamedata.player[idx].spr->orientation) >> 11;
      stepy = FAT_Sin16384 (gamedata.player[idx].spr->orientation) >> 11;
      newxpos = gamedata.player[idx].spr->xpos + stepx;
      newypos = gamedata.player[idx].spr->ypos + stepy;
    }
  AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);
  //---More complicated: See if the enemy can see other players-----
#define ACTOR_SIZE ((long)(64L<<7L))
#define MIN_DIST   ((long)(10L<<7L))
  for (a = gamedata.sprites.players; a >= NO_TARGETING_REAL_PLAYER; a--)
    {
      if (a == idx)
	continue;

//If a wall is in-between, check another player
      if (RayBlocked
	  (fc, gamedata.player[idx].spr->xpos, gamedata.player[idx].spr->ypos,
	   gamedata.player[a].spr->xpos, gamedata.player[a].spr->ypos))
	continue;

      dx =
	(long) (gamedata.player[a].spr->xpos -
		gamedata.player[idx].spr->xpos);
      dy =
	(long) (gamedata.player[a].spr->ypos -
		gamedata.player[idx].spr->ypos);

      nx =
	dx * (long) FAT_Sin16384 (ANGLE_090 +
				  gamedata.player[idx].spr->orientation) +
	dy * (long) FAT_Sin16384 (gamedata.player[idx].spr->orientation);

      if (!(nx < (MIN_DIST + ACTOR_SIZE)))
	{
	  gamedata.player[idx].desire = ENEMY_DM_CHASE;
	  gamedata.player[idx].data = a;
	  break;
	}
    }

}

#define ATTACK_DISTANCE 128
void
AI_DM_CHASE (FATCONFIG * fc, short idx)
{
//This is pretty much done.
  short x = gamedata.player[idx].spr->xpos;
  short y = gamedata.player[idx].spr->ypos;
  short dx = gamedata.player[gamedata.player[idx].data].spr->xpos - x;
  short dy = gamedata.player[gamedata.player[idx].data].spr->ypos - y;
  short angle;
  short stepx;
  short stepy;
  short newxpos;
  short newypos;
  long distance_squared;
  unsigned long distance;

  angle = FAT_GetArcTanYX (dy, dx);
  gamedata.player[idx].spr->orientation =
    angle + random (ANGLE_015 / 2) - (ANGLE_015 / 4);

  //Try to go in the facing direction
  stepx = FAT_Cos16384 (gamedata.player[idx].spr->orientation) >> 11;
  stepy = FAT_Sin16384 (gamedata.player[idx].spr->orientation) >> 11;
  newxpos = gamedata.player[idx].spr->xpos + stepx;
  newypos = gamedata.player[idx].spr->ypos + stepy;
  //If the move is invalid, go back to the walk code for a while
  if (!ValidMove (fc, newxpos, newypos))
    {
      gamedata.player[idx].desire = ENEMY_DM_WALK;
      gamedata.player[idx].move = WAIT_AMOUNT;
    }

  else
    AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);
  distance_squared = dx * dx + dy * dy;
  distance = FAT_FastSqrt (distance_squared);
  //If the bot is close enough, attack
  if (distance < ATTACK_DISTANCE)
    {
      gamedata.player[idx].rx = gamedata.player[idx].spr->xpos;
      gamedata.player[idx].ry = gamedata.player[idx].spr->ypos;
      gamedata.player[idx].desire = ENEMY_DM_ATTACK;

    }

}

void
AI_DM_ATTACK (FATCONFIG * fc, short idx)
{
//To do: Strafing, evasiveness, etc
  short x = gamedata.player[idx].spr->xpos;
  short y = gamedata.player[idx].spr->ypos;
  short dx = gamedata.player[gamedata.player[idx].data].spr->xpos - x;
  short dy = gamedata.player[gamedata.player[idx].data].spr->ypos - y;
  short angle;
  short stepx = 0;
  short stepy = 0;
  short newxpos = 0;
  short newypos = 0;
  short t = 0;

  fc = fc;

  angle = FAT_GetArcTanYX (dy, dx);
  gamedata.player[idx].spr->orientation = angle;

  while (!ValidMove (fc, newxpos, newypos) && t < 4)
    {
      stepx =
	FAT_Cos16384 (FAT_ClampAngle
		      (gamedata.player[idx].spr->orientation +
		       gamedata.player[idx].sangle)) >> 11;
      stepy =
	FAT_Sin16384 (FAT_ClampAngle
		      (gamedata.player[idx].spr->orientation +
		       gamedata.player[idx].sangle)) >> 11;
      newxpos = gamedata.player[idx].rx + stepx * 2;
      newypos = gamedata.player[idx].ry + stepy * 2;
      //If the move isn't valid, try the other way
      if (t)
	gamedata.player[idx].dir = -gamedata.player[idx].dir;
      t++;
    }
  //Move the bot
  AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);
  //Circle strafing!
  //sangle is the angle around the circle the player is making
  gamedata.player[idx].sangle += (ANGLE_015 / 2) * gamedata.player[idx].dir;
  if (gamedata.player[idx].sangle >= ANGLE_360)
    gamedata.player[idx].sangle = ANGLE_000;


  dx =
    gamedata.player[gamedata.player[idx].data].spr->xpos -
    gamedata.player[idx].spr->xpos;
  dy =
    gamedata.player[gamedata.player[idx].data].spr->ypos -
    gamedata.player[idx].spr->ypos;
//Find the angle to the player
  angle = FAT_GetArcTanYX (dy, dx);
//Add some random values depending on difficulty (Accuracy)
  gamedata.player[idx].spr->orientation =
    angle + random (48 - (gamedata.skill << 3)) -
    ((48 - (gamedata.skill << 3)) >> 1);

//If the bot can still see the targetting player, fire a rocket
  if (!RayBlocked
      (fc, gamedata.player[idx].spr->xpos, gamedata.player[idx].spr->ypos,
       gamedata.player[gamedata.player[idx].data].spr->xpos,
       gamedata.player[gamedata.player[idx].data].spr->ypos))
    SpawnRocket (fc, idx);
//Otherwise, chase the player some more
  else
    gamedata.player[idx].desire = ENEMY_DM_CHASE;
}




void
AI_TEAM_WALK (FATCONFIG * fc, short idx)
{
//TO DO: Make more interesting :-)
//Probably should turn sometimes if a player isn't seen
  short stepx;
  short stepy;
  short newxpos;
  short newypos;

  short a;
  short dx;
  short dy;
  long nx;


  //------------Simple movement stuff---------
  //Try to go in the facing direction
  stepx = FAT_Cos16384 (gamedata.player[idx].spr->orientation) >> 11;
  stepy = FAT_Sin16384 (gamedata.player[idx].spr->orientation) >> 11;
  newxpos = gamedata.player[idx].spr->xpos + stepx;
  newypos = gamedata.player[idx].spr->ypos + stepy;
  //If it doesn't work, turn until it does
  while (!ValidMove (fc, newxpos, newypos))
    {
      gamedata.player[idx].spr->orientation =
	FAT_ClampAngle (gamedata.player[idx].spr->orientation + ANGLE_015);
      stepx = FAT_Cos16384 (gamedata.player[idx].spr->orientation) >> 11;
      stepy = FAT_Sin16384 (gamedata.player[idx].spr->orientation) >> 11;
      newxpos = gamedata.player[idx].spr->xpos + stepx;
      newypos = gamedata.player[idx].spr->ypos + stepy;
    }
  AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);
  //---More complicated: See if the enemy can see other players-----
#define ACTOR_SIZE ((long)(64L<<7L))
#define MIN_DIST   ((long)(10L<<7L))
  for (a = gamedata.sprites.players; a >= NO_TARGETING_REAL_PLAYER; a--)
    {
      if (a == idx)
	continue;
      if (gamedata.player[a].team == gamedata.player[idx].team)
	continue;
//If the move is invalid, go back to the walk code for a while
      if (RayBlocked
	  (fc, gamedata.player[idx].spr->xpos, gamedata.player[idx].spr->ypos,
	   gamedata.player[a].spr->xpos, gamedata.player[a].spr->ypos))
	continue;

      dx =
	(long) (gamedata.player[a].spr->xpos -
		gamedata.player[idx].spr->xpos);
      dy =
	(long) (gamedata.player[a].spr->ypos -
		gamedata.player[idx].spr->ypos);

      nx =
	dx * (long) FAT_Sin16384 (ANGLE_090 +
				  gamedata.player[idx].spr->orientation) +
	dy * (long) FAT_Sin16384 (gamedata.player[idx].spr->orientation);

      if (!(nx < (MIN_DIST + ACTOR_SIZE)))
	{
	  gamedata.player[idx].desire = ENEMY_TEAM_CHASE;
	  gamedata.player[idx].data = a;
	  break;
	}

    }

}

void
AI_TEAM_CHASE (FATCONFIG * fc, short idx)
{
//This is pretty much done.
  short x = gamedata.player[idx].spr->xpos;
  short y = gamedata.player[idx].spr->ypos;
  short dx = gamedata.player[gamedata.player[idx].data].spr->xpos - x;
  short dy = gamedata.player[gamedata.player[idx].data].spr->ypos - y;
  short angle;
  short stepx;
  short stepy;
  short newxpos;
  short newypos;
  long distance_squared;
  unsigned long distance;

  angle = FAT_GetArcTanYX (dy, dx);
  gamedata.player[idx].spr->orientation =
    angle + random (ANGLE_015 / 2) - (ANGLE_015 / 4);

  //Try to go in the facing direction
  stepx = FAT_Cos16384 (gamedata.player[idx].spr->orientation) >> 11;
  stepy = FAT_Sin16384 (gamedata.player[idx].spr->orientation) >> 11;
  newxpos = gamedata.player[idx].spr->xpos + stepx;
  newypos = gamedata.player[idx].spr->ypos + stepy;
//If the move is invalid, go back to the walk code for a while
  if (!ValidMove (fc, newxpos, newypos))
    {
      gamedata.player[idx].move = WAIT_AMOUNT;
      gamedata.player[idx].desire = ENEMY_TEAM_WALK;
    }

  else
    AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);
  distance_squared = dx * dx + dy * dy;
  distance = FAT_FastSqrt (distance_squared);
  //If the bot is close enough, attack
  if (distance < ATTACK_DISTANCE)
    {
      gamedata.player[idx].rx = gamedata.player[idx].spr->xpos;
      gamedata.player[idx].ry = gamedata.player[idx].spr->ypos;
      gamedata.player[idx].desire = ENEMY_TEAM_ATTACK;

    }

}

void
AI_TEAM_ATTACK (FATCONFIG * fc, short idx)
{

  short x = gamedata.player[idx].spr->xpos;
  short y = gamedata.player[idx].spr->ypos;
  short dx = gamedata.player[gamedata.player[idx].data].spr->xpos - x;
  short dy = gamedata.player[gamedata.player[idx].data].spr->ypos - y;
  short angle;
  short stepx = 0;
  short stepy = 0;
  short newxpos = 0;
  short newypos = 0;
  short t = 0;

  fc = fc;

  angle = FAT_GetArcTanYX (dy, dx);
  gamedata.player[idx].spr->orientation = angle;

  while (!ValidMove (fc, newxpos, newypos) && t < 4)
    {
      stepx =
	FAT_Cos16384 (FAT_ClampAngle
		      (gamedata.player[idx].spr->orientation +
		       gamedata.player[idx].sangle)) >> 11;
      stepy =
	FAT_Sin16384 (FAT_ClampAngle
		      (gamedata.player[idx].spr->orientation +
		       gamedata.player[idx].sangle)) >> 11;
      newxpos = gamedata.player[idx].rx + stepx * 2;
      newypos = gamedata.player[idx].ry + stepy * 2;
      //If the move isn't valid, try the other way
      if (t)
	gamedata.player[idx].dir = -gamedata.player[idx].dir;
      t++;
    }

  AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);

  gamedata.player[idx].sangle += (ANGLE_015 / 2) * gamedata.player[idx].dir;
  if (gamedata.player[idx].sangle >= ANGLE_360)
    gamedata.player[idx].sangle = ANGLE_000;


  dx =
    gamedata.player[gamedata.player[idx].data].spr->xpos -
    gamedata.player[idx].spr->xpos;
  dy =
    gamedata.player[gamedata.player[idx].data].spr->ypos -
    gamedata.player[idx].spr->ypos;
//Find the angle to the player
  angle = FAT_GetArcTanYX (dy, dx);
//Add some random values depending on difficulty (Accuracy)
  gamedata.player[idx].spr->orientation =
    angle + random (48 - (gamedata.skill << 3)) -
    ((48 - (gamedata.skill << 3)) >> 1);
//If the bot can still see the targetting player, fire a rocket
  if (!RayBlocked
      (fc, gamedata.player[idx].spr->xpos, gamedata.player[idx].spr->ypos,
       gamedata.player[gamedata.player[idx].data].spr->xpos,
       gamedata.player[gamedata.player[idx].data].spr->ypos))
    SpawnRocket (fc, idx);
//Otherwise, chase the player some more
  else
    gamedata.player[idx].desire = ENEMY_TEAM_CHASE;
}


void
AI_CTF_WALK (FATCONFIG * fc, short idx)
{
//TO DO: Lots of stuff
  short stepx;
  short stepy;
  short newxpos;
  short newypos;

  short a;
  short dx;
  short dy;
  long nx;

  if (gamedata.player[idx].move)
    gamedata.player[idx].move--;
  if (!gamedata.player[idx].move)
    {
      if (gamedata.player[idx].order == CTF_DEFENDER)
	{
	  gamedata.player[idx].desire = ENEMY_CTF_DEFEND;
	}
      else if (gamedata.player[idx].order == CTF_ATTACKER)
	{
	  gamedata.player[idx].desire = ENEMY_CTF_CHARGE;
	}
    }

  //------------Simple movement stuff---------
  //Try to go in the facing direction
  stepx = FAT_Cos16384 (gamedata.player[idx].spr->orientation) >> 11;
  stepy = FAT_Sin16384 (gamedata.player[idx].spr->orientation) >> 11;
  newxpos = gamedata.player[idx].spr->xpos + stepx;
  newypos = gamedata.player[idx].spr->ypos + stepy;
  //If it doesn't work, turn until it does
  while (!ValidMove (fc, newxpos, newypos))
    {
      gamedata.player[idx].spr->orientation =
	FAT_ClampAngle (gamedata.player[idx].spr->orientation + ANGLE_015);
      stepx = FAT_Cos16384 (gamedata.player[idx].spr->orientation) >> 11;
      stepy = FAT_Sin16384 (gamedata.player[idx].spr->orientation) >> 11;
      newxpos = gamedata.player[idx].spr->xpos + stepx;
      newypos = gamedata.player[idx].spr->ypos + stepy;
    }
  AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);
  //---More complicated: See if the enemy can see other players-----
#define ACTOR_SIZE ((long)(64L<<7L))
#define MIN_DIST   ((long)(10L<<7L))
  for (a = gamedata.sprites.players; a >= NO_TARGETING_REAL_PLAYER; a--)
    {
      if (a == idx)
	continue;
      if (gamedata.player[a].team == gamedata.player[idx].team)
	continue;
//If a wall is inbetween, find another player
      if (RayBlocked
	  (fc, gamedata.player[idx].spr->xpos, gamedata.player[idx].spr->ypos,
	   gamedata.player[a].spr->xpos, gamedata.player[a].spr->ypos))
	continue;

      dx =
	(long) (gamedata.player[a].spr->xpos -
		gamedata.player[idx].spr->xpos);
      dy =
	(long) (gamedata.player[a].spr->ypos -
		gamedata.player[idx].spr->ypos);

      nx =
	dx * (long) FAT_Sin16384 (ANGLE_090 +
				  gamedata.player[idx].spr->orientation) +
	dy * (long) FAT_Sin16384 (gamedata.player[idx].spr->orientation);

      if (!(nx < (MIN_DIST + ACTOR_SIZE)))
	{
	  gamedata.player[idx].desire = ENEMY_CTF_ATTACK;
	  gamedata.player[idx].data = a;
	  break;
	}
    }

}

//Defense bots
void
AI_CTF_DEFEND (FATCONFIG * fc, short idx)
{
  short x = gamedata.player[idx].spr->xpos;
  short y = gamedata.player[idx].spr->ypos;
  short dx = gamedata.flag[gamedata.player[idx].team].spr->xpos - x;
  short dy = gamedata.flag[gamedata.player[idx].team].spr->ypos - y;
  short angle;
  short stepx;
  short stepy;
  short newxpos;
  short newypos;
  long distance_squared;
  unsigned long distance;

  angle = FAT_GetArcTanYX (dy, dx);
  gamedata.player[idx].spr->orientation =
    angle + random (ANGLE_015 / 2) - (ANGLE_015 / 4);

  //Try to go in the facing direction
  stepx = FAT_Cos16384 (gamedata.player[idx].spr->orientation) >> 11;
  stepy = FAT_Sin16384 (gamedata.player[idx].spr->orientation) >> 11;
  newxpos = gamedata.player[idx].spr->xpos + stepx;
  newypos = gamedata.player[idx].spr->ypos + stepy;

  x = gamedata.player[idx].spr->xpos;
  y = gamedata.player[idx].spr->ypos;
  AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);
//If the move doesn't take the bot far, go back to walk code
  if (((x >> 1) + 1 == (gamedata.player[idx].spr->xpos >> 1) + 1) &&
      ((y >> 1) + 1 == (gamedata.player[idx].spr->ypos >> 1) + 1))
    {
      gamedata.player[idx].move = WAIT_AMOUNT;
      gamedata.player[idx].desire = ENEMY_CTF_WALK;
    }

  distance_squared = dx * dx + dy * dy;
  distance = FAT_FastSqrt (distance_squared);
  if (distance < ATTACK_DISTANCE * 2)
    {
      gamedata.player[idx].rx = gamedata.player[idx].spr->xpos;
      gamedata.player[idx].ry = gamedata.player[idx].spr->ypos;
      gamedata.player[idx].desire = ENEMY_CTF_WALK;
    }

}

//Charge bots (attack the enemy base, take flag, etc)
void
AI_CTF_CHARGE (FATCONFIG * fc, short idx)
{
  short x = gamedata.player[idx].spr->xpos;
  short y = gamedata.player[idx].spr->ypos;
  //Point to flag of opposite team
  short dx = gamedata.flag[gamedata.player[idx].team ? 0 : 1].spr->xpos - x;
  short dy = gamedata.flag[gamedata.player[idx].team ? 0 : 1].spr->ypos - y;
  short angle;
  short stepx;
  short stepy;
  short newxpos;
  short newypos;
  long distance_squared;
  unsigned long distance;

  angle = FAT_GetArcTanYX (dy, dx);
  gamedata.player[idx].spr->orientation =
    angle + random (ANGLE_015 / 2) - (ANGLE_015 / 4);

  //Try to go in the facing direction
  stepx = FAT_Cos16384 (gamedata.player[idx].spr->orientation) >> 11;
  stepy = FAT_Sin16384 (gamedata.player[idx].spr->orientation) >> 11;
  newxpos = gamedata.player[idx].spr->xpos + stepx;
  newypos = gamedata.player[idx].spr->ypos + stepy;

  x = gamedata.player[idx].spr->xpos;
  y = gamedata.player[idx].spr->ypos;
  AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);
//If the move is too small, go back to walking
  if (((x >> 1) + 1 == (gamedata.player[idx].spr->xpos >> 1) + 1) &&
      ((y >> 1) + 1 == (gamedata.player[idx].spr->ypos >> 1) + 1))
    {
      gamedata.player[idx].move = WAIT_AMOUNT;
      gamedata.player[idx].desire = ENEMY_CTF_WALK;
    }

  else
    AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);
  distance_squared = dx * dx + dy * dy;
  distance = FAT_FastSqrt (distance_squared);
  if (distance <= ATTACK_DISTANCE / 8)	//Bot got the flag, needs to return to home base
    {
      gamedata.player[idx].desire = ENEMY_CTF_DEFEND;	//i.e. will return to home base
    }

}

void
AI_CTF_ATTACK (FATCONFIG * fc, short idx)
{
  short x = gamedata.player[idx].spr->xpos;
  short y = gamedata.player[idx].spr->ypos;
  short dx = gamedata.player[gamedata.player[idx].data].spr->xpos - x;
  short dy = gamedata.player[gamedata.player[idx].data].spr->ypos - y;
  short angle;
  short stepx;
  short stepy;
  short newxpos;
  short newypos;
  long distance_squared;
  unsigned long distance;

  angle = FAT_GetArcTanYX (dy, dx);
  gamedata.player[idx].spr->orientation =
    angle + random (ANGLE_015 / 2) - (ANGLE_015 / 4);

  distance_squared = dx * dx + dy * dy;
  distance = FAT_FastSqrt (distance_squared);

  if (distance >= ATTACK_DISTANCE)
    {
      //Try to go in the facing direction
      stepx = FAT_Cos16384 (gamedata.player[idx].spr->orientation) >> 11;
      stepy = FAT_Sin16384 (gamedata.player[idx].spr->orientation) >> 11;
      newxpos = gamedata.player[idx].spr->xpos + stepx;
      newypos = gamedata.player[idx].spr->ypos + stepy;

      x = gamedata.player[idx].spr->xpos;
      y = gamedata.player[idx].spr->ypos;
      AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);
      //If the move is too small, go back to walking
      if (((x >> 1) + 1 == (gamedata.player[idx].spr->xpos >> 1) + 1) &&
	  ((y >> 1) + 1 == (gamedata.player[idx].spr->ypos >> 1) + 1))
	{
	  gamedata.player[idx].move = WAIT_AMOUNT;
	  gamedata.player[idx].desire = ENEMY_CTF_WALK;
	}

      else
	AIMove (fc, gamedata.player[idx].spr, stepx, stepy, newxpos, newypos);
    }

  else
    {
      gamedata.player[idx].rx = gamedata.player[idx].spr->xpos;
      gamedata.player[idx].ry = gamedata.player[idx].spr->ypos;
//If path is clear, fire!
      if (!RayBlocked
	  (fc, gamedata.player[idx].spr->xpos, gamedata.player[idx].spr->ypos,
	   gamedata.player[gamedata.player[idx].data].spr->xpos,
	   gamedata.player[gamedata.player[idx].data].spr->ypos))
	SpawnRocket (fc, idx);
//Otherwise return to standard duty
      else
	{
	  if (gamedata.player[idx].order == CTF_DEFENDER)
	    {
	      gamedata.player[idx].desire = ENEMY_CTF_DEFEND;
	    }
	  else if (gamedata.player[idx].order == CTF_ATTACKER)
	    {
	      gamedata.player[idx].desire = ENEMY_CTF_CHARGE;
	    }
	  else
	    gamedata.player[idx].desire = ENEMY_CTF_WALK;
	}

    }

}


//If all AI functions are implemented,
//these names should correspond to the
//Enum of EnemyDesires, in defs.h.
void *AIfunctions[EnemyDesireCount] = {
  AI_DM_WALK,
  AI_DM_CHASE,
  AI_DM_ATTACK,
  AI_TEAM_WALK,
  AI_TEAM_CHASE,
  AI_TEAM_ATTACK,

  AI_CTF_WALK,
  AI_CTF_DEFEND,
  AI_CTF_CHARGE,
  AI_CTF_ATTACK
    //AI_CTF_FLAGRETURN,
    //AI_CTF_FLAGCHASE,
    //AI_CTF_FLAGPROTECT  
};
