// C Header File
// Created 8/24/2002; 12:46:31 PM

#define NAME_VERSION_STRING "Arena 3D v0.65"
#define AUTHOR_STRING "By Malcolm Smith"
#define END_STRING "Make levels, send to m@malcolm-s.net."

#define WON_STRING "You've WON the match!"
#define LOST_STRING "You've LOST the match."

#define MOVE_SPEED (2*gamedata.speed)	//For movement speed (FAT normally is 1)
#define TURN_SPEED (1*gamedata.speed)	//For turning speed  (FAT normally is 1)
#define ROCKET_SPEED (3)
#define MAX_MULTIPLIER 10
#define MULTIPLIER_WIDTH 4

#if ((MAX_MULTIPLIER*MULTIPLIER_WIDTH)+100)>=160
#error MAX_MULTIPLIER OR MULTIPLIER_WIDTH MUST BE LESS!
#endif

#define MAX_GAME_CYCLES_FOR_MULTIPLIER 120
#define MULTIPLIER_DIVISOR (MAX_GAME_CYCLES_FOR_MULTIPLIER/MAX_MULTIPLIER)

#define ROCKET_DAMAGE 10

#define GFX_FILE_COUNT 3

#define MAX_ROCKETS_PER_PLAYER 3
#define MAX_PLAYERS 5
#define REAL_PLAYER_ROCKET_EXTRA 0
#define MAX_ROCKETS ((MAX_ROCKETS_PER_PLAYER*MAX_PLAYERS) +\
 (MAX_ROCKETS_PER_PLAYER+REAL_PLAYER_ROCKET_EXTRA))
#define MAX_SPRITES (MAX_PLAYERS + MAX_ROCKETS + 2)	//2 is for CTF flags

#ifndef SpriteStatusEnum
#define SpriteStatusEnum
enum SpriteStatusEnum
{
  SPRITE_FREE, SPRITE_INUSE
};
#endif

#define REAL_PLAYER_IDX 0

#define SIGN(x) (x>=0?1:-1)
#define AIcall(a) ((void(*)(FATCONFIG*,short))(AIfunctions[gamedata.player[a].desire])) (fc,cur)
#define KeyCheck(k) (_keytest(gamedata.cfg.k.row,gamedata.cfg.k.key))
#define Pressed(x) (_keytest(x))
#define KeyIsPressed (_rowread(0) & 0xff)

#ifndef FileConstant
#define FileConstant
enum FileConstants
{ HOWMANY = 50, MAXLEN = 9 };
#endif

#ifndef ErrorEnum
#define ErrorEnum
#define ARENA_ERROR_COUNT 4
enum ArenaErrors
{
  ARENA_OUT_OF_MEM,
  ARENA_GFX_FILE_ERROR,
  ARENA_MAP_INCORRECT_ERROR,
  ARENA_MAP_FILE_ERROR
};
const char *const ArenaErrorStrings[ARENA_ERROR_COUNT] = {
  "ERROR: Out of Memory",
  "ERROR: Of GFX in a3dgfx[1/2/3]",
  "ERROR: Map is missing needed tiles!",
  "ERROR: Map file error!"
};
const char *const ArenaParameterError =
  "arena(set,lev,dmteams?,bots,skill,lim)";
const char *const FatErrorStrings[] = {
  "ERROR: Unknown FAT Error",
  "ERROR: Game not ExePacked",
  "ERROR: Send this FATLIB version",
  "ERROR: Locking FATengine failed",
  "ERROR: FAT: Out of Memory"
};
#endif

#ifndef EnemyDesires
#define EnemyDesires
#define EnemyDesireCount 10
enum EnemyDesires
{
  ENEMY_DM_WALK, ENEMY_DM_CHASE, ENEMY_DM_ATTACK, ENEMY_TEAM_WALK,
  ENEMY_TEAM_CHASE, ENEMY_TEAM_ATTACK, ENEMY_CTF_WALK, ENEMY_CTF_DEFEND,
  ENEMY_CTF_CHARGE, ENEMY_CTF_ATTACK
    //,ENEMY_CTF_FLAGRETURN
    //,ENEMY_CTF_FLAGCHASE
    //,ENEMY_CTF_FLAGPROTECT
};
#endif

#ifndef Arena_GameTypes
#define Arena_GameTypes
#define MAX_GAMETYPES 3
const char *const ArenaGameTypes[MAX_GAMETYPES] = {
  "DM", "Team", "CTF"
};
enum Arena_Gametypes
{
  DM, TEAM, CTF
};
enum CTF_Tags
{
  WHITE_AREA = -1, GRAY_AREA = -2, WHITE_FLAG = -3, GRAY_FLAG = -4
};
enum CTF_Teams
{
  GRAY_TEAM, WHITE_TEAM
};
enum CTF_Points
{
  FLAG_CAPTURE = 10, FLAG_RETURN = 5
};
enum CTF_Orders
{
  CTF_ATTACKER, CTF_DEFENDER, CTF_WALKER
};
#endif

#define E2Q(a) (-a-1)
#define ArenaShowError(a)		ST_helpMsg(ArenaErrorStrings[a])
#define ShowFatLoadError(a) ST_helpMsg(FatErrorStrings[a])

short display_offsetx = 0;	// will be set depending on calctype (TI89 or TI92p)
short display_offsety = 0;	// will be set depending on calctype (TI89 or TI92p)

#define squared(a) ((a)*(a))

FATSPRITE *allspr = NULL;	// the sprite structure POINTER itself
FATSPRITE *player = NULL;

short noskip;

char *lscr = NULL;
char *dscr = NULL;

char *ext_level_data = NULL;
char setname[9];
short skipidx;
COUNTER health;
COUNTER score;

TEXCONFIG sprite_tex[TOTAL_TEXCONFIGS_IN_a3dgfx2];	// structures for sprites
TEXCONFIG level_tex[TOTAL_TEXCONFIGS_IN_a3dgfx1];	// structures for textures
short *bg_img_data[TOTAL_GENERICDATAS_IN_a3dgfx1] = { NULL };	// pointers for backgrounds
short *arena_img_data = NULL;	//pointer for Arena logo
TEXCONFIG model_tex[TOTAL_TEXCONFIGS_IN_a3dgfx3];	// structures for shot models
short *crosshairs[TOTAL_CROSSHAIRS] = { NULL };	//for crosshair GFX

short *HUDlight = NULL;		//For the HUD space
short *HUDdark = NULL;		//For the HUD space
short *HUDmask = NULL;		//For the HUD space

typedef struct
{
  short x;
  short y;
}
RespawnStruct;
RespawnStruct respawns[(MAX_PLAYERS + 1) * 2];

HANDLE gfxfile[GFX_FILE_COUNT] = { 0 };

typedef struct
{
  short row;
  short key;
}
RowKey;

typedef struct
{
  short fatlogo;
  short arenalogo;
  RowKey fire;
  RowKey strafe;
  RowKey hitfind;
  RowKey speedup;
  short crosshair;
  short radar;
  char name[9];
}
ConfigStruct;

typedef struct
{
/* inuse information:
		0: not in use
		1: traveling
		-1: explosion frame 1
		-2: explosion frame 2
		-3: explosion frame 3
		-4: explosion frame 4
		-5: explosion frame 5
		-6: explosion frame 6
*/
  short inuse;
  short player_idx;		//That the rocket came from
  short player_hit_idx;		//That the rocket hits (if applicable)
  short cur_idx;		//Current sprite that the rocket is
  short multiplier;		//Damage multiplier the rocket will inflict
  FATSPRITE spr;
}
RocketMultiStruct;

typedef struct
{
  short inuse;
  short player_idx;
  short base_x;
  short base_y;
  FATSPRITE *spr;
}
FlagMultiStruct;

typedef struct
{
  short rockets;
  short players;
  short ctfflags;
}
SpriteSingleStruct;

typedef struct
{
  short score;
}
TeamStruct;

typedef struct
{
  short score;			// (points, kills, frags)
  short health;
  short last_hit_dir;

  FATSPRITE *spr;

  short model;
  short team;			//In CTF or Teamplay DM, 0 = Gray, 1 = White
  short order;			//CTF only
  short rocket_idx;		//Total number of current rockets
  short rocket_multiplier;	//Damage multiplier, depends on when the last shot was fired
  short multiplier_count;

  short desire;
  short data;
  short dir;
  short move;
  short rx;
  short ry;
  short sangle;
}
PlayerStruct;

typedef struct
{
  short quitting;


  short gametype;
  short teamflag;
  short instagib;

  short invert;

  short skill;
  short scorelimit;

  short speed;
  short negated;


  ConfigStruct cfg;

  RocketMultiStruct rocket[MAX_ROCKETS + 1];
  FlagMultiStruct flag[2];

  SpriteSingleStruct sprites;

  PlayerStruct player[MAX_PLAYERS + 1];
  TeamStruct team[2];


}
game_struct;

game_struct gamedata;

unsigned long count5_start;
