// C Header File
// Created 10/20/2002; 12:18:35 PM

void
ResetFlag (short team_idx)
{
  gamedata.flag[team_idx].spr->xpos = gamedata.flag[team_idx].base_x;
  gamedata.flag[team_idx].spr->ypos = gamedata.flag[team_idx].base_y;
  gamedata.flag[team_idx].inuse = SPRITE_FREE;
}

void
CTFhandle (void)
{
#define CTF_FLAG_ACCURACY 6
  short a;
  //If the flags are still at their bases, see if someone is taking them
  if (gamedata.flag[GRAY_TEAM].inuse == SPRITE_FREE
      || gamedata.flag[WHITE_TEAM].inuse == SPRITE_FREE)
    {
      for (a = gamedata.sprites.players; a >= 0; a--)
	{
	  if (gamedata.flag[GRAY_TEAM].inuse == SPRITE_FREE)
	    {
	      if (gamedata.player[a].team != GRAY_TEAM)
		{
		  if ((gamedata.player[a].spr->xpos +
		       (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY ==
		      (gamedata.flag[GRAY_TEAM].spr->xpos +
		       (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY
		      && (gamedata.player[a].spr->ypos +
			  (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY
		      ==
		      (gamedata.flag[GRAY_TEAM].spr->ypos +
		       (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY)
		    {
		      gamedata.flag[GRAY_TEAM].inuse = SPRITE_INUSE;
		      gamedata.flag[GRAY_TEAM].player_idx = a;
		    }
		}
	    }
	  if (gamedata.flag[WHITE_TEAM].inuse == SPRITE_FREE)
	    {
	      if (gamedata.player[a].team != WHITE_TEAM)
		{
		  if ((gamedata.player[a].spr->xpos +
		       (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY ==
		      (gamedata.flag[WHITE_TEAM].spr->xpos +
		       (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY
		      && (gamedata.player[a].spr->ypos +
			  (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY
		      ==
		      (gamedata.flag[WHITE_TEAM].spr->ypos +
		       (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY)
		    {
		      gamedata.flag[WHITE_TEAM].inuse = SPRITE_INUSE;
		      gamedata.flag[WHITE_TEAM].player_idx = a;
		    }
		}
	    }
	}
    }
  //If the flags aren't at their bases, adjust their position
  if (gamedata.flag[WHITE_TEAM].inuse == SPRITE_INUSE)
    {
      gamedata.flag[WHITE_TEAM].spr->xpos =
	gamedata.player[gamedata.flag[WHITE_TEAM].player_idx].spr->xpos;
      gamedata.flag[WHITE_TEAM].spr->ypos =
	gamedata.player[gamedata.flag[WHITE_TEAM].player_idx].spr->ypos;
    }
  if (gamedata.flag[GRAY_TEAM].inuse == SPRITE_INUSE)
    {
      gamedata.flag[GRAY_TEAM].spr->xpos =
	gamedata.player[gamedata.flag[GRAY_TEAM].player_idx].spr->xpos;
      gamedata.flag[GRAY_TEAM].spr->ypos =
	gamedata.player[gamedata.flag[GRAY_TEAM].player_idx].spr->ypos;
    }
  if ((gamedata.flag[WHITE_TEAM].spr->xpos +
       (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY ==
      (gamedata.flag[GRAY_TEAM].spr->xpos +
       (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY
      && (gamedata.flag[WHITE_TEAM].spr->ypos +
	  (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY ==
      (gamedata.flag[GRAY_TEAM].spr->ypos +
       (1 << (CTF_FLAG_ACCURACY / 2))) >> CTF_FLAG_ACCURACY)
    {
      if (gamedata.flag[WHITE_TEAM].inuse == SPRITE_FREE &&
	  gamedata.flag[GRAY_TEAM].inuse == SPRITE_INUSE)
	{
	  gamedata.team[WHITE_TEAM].score++;
	  gamedata.player[gamedata.flag[GRAY_TEAM].player_idx].score += 10;
	  ResetFlag (GRAY_TEAM);
	  if (gamedata.team[WHITE_TEAM].score == gamedata.scorelimit
	      && gamedata.scorelimit > 0)
	    {
	      gamedata.quitting = 2;
	    }
	}
      else if (gamedata.flag[GRAY_TEAM].inuse == SPRITE_FREE &&
	       gamedata.flag[WHITE_TEAM].inuse == SPRITE_INUSE)
	{
	  gamedata.team[GRAY_TEAM].score++;
	  gamedata.player[gamedata.flag[WHITE_TEAM].player_idx].score += 10;
	  ResetFlag (WHITE_TEAM);
	  if (gamedata.team[GRAY_TEAM].score == gamedata.scorelimit
	      && gamedata.scorelimit > 0)
	    {
	      gamedata.quitting = 2;
	    }
	}
    }

}
