// C Header File
// Created 8/24/2002; 12:46:57 PM

#define A_HUD A_REVERSE

unsigned char health_icon[16] = {
  0xff, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0xff,
  0xff, 0x99, 0x99, 0xff, 0xff, 0x99, 0x99, 0xff
};

unsigned char score_icon[16] = {
  0x00, 0x7e, 0x40, 0x7e, 0x7e, 0x02, 0x7e, 0x00,
  0x00, 0x7e, 0x40, 0x7e, 0x7e, 0x02, 0x7e, 0x00
};
unsigned char minus_spr[8] = {
  0xFF, 0xFF, 0xFF, 0xC3, 0xC3, 0xFF, 0xFF, 0xFF
};
unsigned char black9[9] = {
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
};

unsigned long compass_spr[64] = {
  0xffffffff, 0xfffc3fff, 0xffc3c3ff, 0xff3c7cff, 0xfec00f7f, 0xf980039f,
  0xfa0000df, 0xf400002f,
  0xec000037, 0xe8000017, 0xd000000b, 0xd000000b, 0xd000000b, 0xd0000001,
  0xa0000005, 0xa0000005,
  0xa0000005, 0xb0000005, 0xf0000005, 0xd000000b, 0xd800000b, 0xd800000b,
  0xec000017, 0xec000037,
  0xf600002f, 0xfa00005f, 0xf980019f, 0xfec0037f, 0xff381cff, 0xffc7e3ff,
  0xfff81fff, 0xffffffff,
  0xffffffff, 0xffffffff, 0xfffc3fff, 0xffc003ff, 0xff0000ff, 0xfe00007f,
  0xfc00003f, 0xf800001f,
  0xf000000f, 0xf000000f, 0xe0000007, 0xe0000007, 0xe0000007, 0xe0000007,
  0xc0000003, 0xc0000003,
  0xc0000003, 0xc0000003, 0xc0000003, 0xe0000007, 0xe0000007, 0xe0000007,
  0xf000000f, 0xf000000f,
  0xf800001f, 0xfc00003f, 0xfe00007f, 0xff0000ff, 0xffc003ff, 0xfff81fff,
  0xffffffff, 0xffffffff
};

#define COMPASS_RADIUS 10
#define COMPASS_X 127
#define COMPASS_Y 85
#define COMPASS_X_LEFT (COMPASS_X-16)
#define COMPASS_Y_TOP (COMPASS_Y-16)
#define COMPASS_LASTHIT_RADIUS 3

#define MULTIPLIER_X 100
#define MULTIPLIER_Y 55
#define MULTIPLIER_HEIGHT 4

//=============================================================================
// initializes GUI (darkgray background, tiny logo, etc)
//=============================================================================
void
InitGUI (void)
{
  score.already_used = 0;
  health.already_used = 0;

  GraySprite8_MASK (100 + display_offsetx, 30 + 1, 8, health_icon,
		    health_icon + 8, health_icon, health_icon, GetPlane (0),
		    GetPlane (1));
  GraySprite8_MASK (100 + display_offsetx, 42 + 1, 8, score_icon,
		    score_icon + 8, score_icon, score_icon, GetPlane (0),
		    GetPlane (1));
  DrawGrayStrExt (97 + display_offsetx, 4 + display_offsety,
		  (char *) NAME_VERSION_STRING, A_HUD, F_4x6);
  DrawGrayStrExt (97 + display_offsetx, 12 + display_offsety,
		  (char *) AUTHOR_STRING, A_HUD, F_4x6);

}

void
ConfigurePlayerName (void)
{
  char buffer[9];
  char full[12];
  short b = 0;
  short key;
  GrayOff ();
  RestoreHandlerForINTs ();
  ClrScr ();
  GrayOn ();
  ClearGrayScreen ();
  DrawGrayStrExt (0, 44, gamedata.cfg.name, A_NORMAL | A_CENTERED, F_6x8);
  DrawGrayStrExt (0, 70, (char *) "Press ENTER to change.",
		  A_NORMAL | A_CENTERED, F_6x8);
  DrawGrayStrExt (0, 80, (char *) "Press another key to exit.",
		  A_NORMAL | A_CENTERED, F_6x8);
  key = ngetchx ();
  if (key != KEY_ENTER)
    {
      GrayOff ();
      InstallDummyHandlerForINTs ();
      GrayOn ();
      return;
    }

  InputInfo (0, 0, buffer, full, 9);
  while (buffer[b])
    b++;
  buffer[b] = ' ';
  buffer[8] = 0;
  strcpy (gamedata.cfg.name, buffer);

  GrayOff ();
  InstallDummyHandlerForINTs ();
  GrayOn ();
  return;
}

void
ConfigureGameKeys (void)
{
  const char *const strs[] = {
    "Fire Key?     ",
    "Strafe Key?   ",
    "Hit Find Key? ",
    "Speed Up Key? "
  };
  short a;
  short row;
  short col;
  RowKey cur;
  char buffer[50];

  BlackGrayScreen ();
  for (a = 0; a < 4; a++)
    {
      DrawGrayStrExt (0, 44, (char *) strs[a], A_REVERSE | A_CENTERED, F_6x8);
      FAT_AllKeysReleased ();
      FAT_WaitKeyPressed ();
      for (row = 0; row < (CALCULATOR ? 10 : 7); row++)
	{
	  for (col = 0; col < 8; col++)
	    {
	      if (_keytest (row, col))
		{
		  cur.row = row;
		  cur.key = col;
		  switch (a)
		    {
		    case 0:
		      memcpy (&gamedata.cfg.fire, &cur, sizeof (RowKey));
		      break;
		    case 1:
		      memcpy (&gamedata.cfg.strafe, &cur, sizeof (RowKey));
		      break;
		    case 2:
		      memcpy (&gamedata.cfg.hitfind, &cur, sizeof (RowKey));
		      break;
		    case 3:
		      memcpy (&gamedata.cfg.speedup, &cur, sizeof (RowKey));
		      break;
		    }
		}
	    }
	}
    }
  BlackGrayScreen ();
  for (a = 0; a < 4; a++)
    {
      switch (a)
	{
	case 0:
	  memcpy (&cur, &gamedata.cfg.fire, sizeof (RowKey));
	  break;
	case 1:
	  memcpy (&cur, &gamedata.cfg.strafe, sizeof (RowKey));
	  break;
	case 2:
	  memcpy (&cur, &gamedata.cfg.hitfind, sizeof (RowKey));
	  break;
	case 3:
	  memcpy (&cur, &gamedata.cfg.speedup, sizeof (RowKey));
	  break;
	}
      sprintf (buffer, "%s: %s", strs[a],
	       CALCULATOR ? TI92plus_rowread[cur.row][cur.
						      key] : TI89_rowread[cur.
									  row]
	       [cur.key]);
      DrawGrayStrExt (5, 20 + a * 10, buffer, A_REVERSE, F_6x8);
    }
  FAT_AllKeysReleased ();
  FAT_WaitKeyPressed ();
  FAT_AllKeysReleased ();
}

typedef struct
{
  short y;
  char *text;
  short font;
}
TitleStruct;


#define UpdateOptionOneText(); 				\
strcpy((char*)option[0].text+18,gamedata.cfg.fatlogo?"Yes":"No ");\
option[0].text[21] = ')';

#define UpdateOptionTwoText(); 				\
strcpy((char*)option[1].text+20,gamedata.cfg.arenalogo?"Yes":"No ");\
option[1].text[23] = ')';

#define UpdateOptionFiveText(); 				\
strcpy((char*)option[4].text+14,gamedata.cfg.crosshair?"Circle":"Cross ");\
option[4].text[20] = ')';

#define UpdateOptionSixText(); 				\
strcpy((char*)option[5].text+10,gamedata.cfg.radar?"Yes":"No ");\
option[5].text[13] = ')';

void
HandleOptions (void)
{
  short a;
  TitleStruct info[2] = {
    {5, (char *) NAME_VERSION_STRING, F_8x10},
    {16, (char *) "GAME OPTIONS", F_8x10}
  };
#define NR_OPTIONS 6
#define PGS_OPTIONS 2
  TitleStruct option[NR_OPTIONS] = {
    {28, (char *) "1. Show FAT logo (---)", F_6x8},
    {37, (char *) "2. Show Arena logo (---)", F_6x8},
    {46, (char *) "3. Configure Keys ...", F_6x8},
    {55, (char *) "4. Player Name ...", F_6x8},
    {64, (char *) "5. Crosshair (------)", F_6x8},
    {73, (char *) "6. Radar (---)", F_6x8}
  };

redraw:
  BlackGrayScreen ();

  UpdateOptionOneText ();
  UpdateOptionTwoText ();
  UpdateOptionFiveText ();
  UpdateOptionSixText ();

  DrawGrayStrExt (10, info[0].y, (char *) info[0].text,
		  A_REVERSE, info[0].font);
  DrawGrayStrExt (10, info[1].y, (char *) info[1].text,
		  A_REVERSE, info[1].font);
  for (a = 0; a < NR_OPTIONS; a++)
    {
      DrawGrayStrExt (10, option[a].y, (char *) option[a].text,
		      A_REVERSE, option[a].font);
    }

  while (!Pressed (RR_ESC))
    {
      if (Pressed (RR_1))
	{
	  FAT_AllKeysReleased ();
	  gamedata.cfg.fatlogo++;
	  if (gamedata.cfg.fatlogo == 2)
	    gamedata.cfg.fatlogo = 0;
	  UpdateOptionOneText ();
	  DrawGrayStrExt (10, option[0].y, (char *) option[0].text,
			  A_REVERSE, option[0].font);
	}
      if (Pressed (RR_2))
	{
	  FAT_AllKeysReleased ();
	  gamedata.cfg.arenalogo++;
	  if (gamedata.cfg.arenalogo == 2)
	    gamedata.cfg.arenalogo = 0;
	  UpdateOptionTwoText ();
	  DrawGrayStrExt (10, option[1].y, (char *) option[1].text,
			  A_REVERSE, option[1].font);
	}

      if (Pressed (RR_3))
	{
	  FAT_AllKeysReleased ();
	  ConfigureGameKeys ();
	  goto redraw;
	}
      if (Pressed (RR_4))
	{
	  FAT_AllKeysReleased ();
	  ConfigurePlayerName ();
	  goto redraw;
	}
      if (Pressed (RR_5))
	{
	  FAT_AllKeysReleased ();
	  gamedata.cfg.crosshair++;
	  if (gamedata.cfg.crosshair == 2)
	    gamedata.cfg.crosshair = 0;
	  UpdateOptionFiveText ();
	  DrawGrayStrExt (10, option[4].y, (char *) option[4].text,
			  A_REVERSE, option[4].font);
	}
      if (Pressed (RR_6))
	{
	  FAT_AllKeysReleased ();
	  gamedata.cfg.radar++;
	  if (gamedata.cfg.radar == 2)
	    gamedata.cfg.radar = 0;
	  UpdateOptionSixText ();
	  DrawGrayStrExt (10, option[5].y, (char *) option[5].text,
			  A_REVERSE, option[5].font);
	}
    }
  FAT_AllKeysReleased ();
}





//Thanks to Thomas Nussbaumer
void
dissolve (void)
{
  unsigned short seq = 1;
  unsigned char pixmask;
  unsigned short byteoffset;

  do
    {
      pixmask = seq & 0x7;
      byteoffset = seq >> 3;

      if (byteoffset < LCD_SIZE)
	{
	  pixmask = 0x80 >> pixmask;

	  //-------------------------------------
	  // if pixel in plane1 is set, delete it
	  // otherwise set it
	  //-------------------------------------
	  //if (*(unsigned char *)(GetPlane(LIGHT_PLANE)+byteoffset) & pixmask) {
	  //        *(unsigned char *)(GetPlane(LIGHT_PLANE)+byteoffset) &= ~pixmask;
	  //  }
	  /*else */
	  if (!
	      (*((unsigned char *) GetPlane (LIGHT_PLANE) + byteoffset) &
	       pixmask))
	    {
	      *((unsigned char *) GetPlane (LIGHT_PLANE) + byteoffset) |=
		pixmask;
	    }

	  //-------------------------------------
	  // if pixel in plane2 is set, delete it
	  // otherwise set it
	  //-------------------------------------
	  //if (*(unsigned char *)(GetPlane(DARK_PLANE)+byteoffset) & pixmask) {
	  //        *(unsigned char *)(GetPlane(DARK_PLANE)+byteoffset) &= ~pixmask;
	  //    }
	  /*else */
	  if (!
	      (*((unsigned char *) GetPlane (DARK_PLANE) + byteoffset) &
	       pixmask))
	    {
	      *((unsigned char *) GetPlane (DARK_PLANE) + byteoffset) |=
		pixmask;
	    }

	}

      if (seq & 1)
	seq = (seq >> 1) ^ 0x6000;
      else
	seq = seq >> 1;
    }
  while (seq != 1);
}

void
dissolveToLCD (char *lcd)
{
  unsigned short seq = 1;
  unsigned char pixmask;
  unsigned short byteoffset;

  do
    {
      pixmask = seq & 0x7;
      byteoffset = seq >> 3;

      if (byteoffset < LCD_SIZE)
	{
	  pixmask = 0x80 >> pixmask;

	  if (*(unsigned char *) (lcd + byteoffset) & pixmask)
	    {
	      *((unsigned char *) GetPlane (LIGHT_PLANE) + byteoffset) |=
		pixmask;
	      *((unsigned char *) GetPlane (DARK_PLANE) + byteoffset) |=
		pixmask;

	    }
	  else
	    {
	      *((unsigned char *) GetPlane (LIGHT_PLANE) + byteoffset) &=
		~pixmask;
	      *((unsigned char *) GetPlane (DARK_PLANE) + byteoffset) &=
		~pixmask;
	    }


	}

      if (seq & 1)
	seq = (seq >> 1) ^ 0x6000;
      else
	seq = seq >> 1;
    }
  while (seq != 1);
}

void
ShowLogo (void)
{
  short a, aa;

  if (gamedata.cfg.arenalogo)
    {
      short cur_plane, b, bb;
      unsigned short *p[2];
      ClearGrayScreen ();
      InvertGrayRect (0, 0, 239, 127);

      for (cur_plane = 0; cur_plane < 2; cur_plane++)
	{
	  p[cur_plane] = GrayGetPlane (cur_plane);
	}
      for (cur_plane = 0; cur_plane < 2; cur_plane++)
	{
	  //Here comes an unrolled loop, kind of
	  for (a = 0, aa = display_offsety; a < 100; a++, aa++)
	    {
	      bb = display_offsetx ? 2 : 0;
	      b = 0;
	      (unsigned short) *(p[cur_plane] + aa * 15 + bb) =
		arena_img_data[(cur_plane * 1000) + a * 10 + b];
	      b++;
	      bb++;
	      (unsigned short) *(p[cur_plane] + aa * 15 + bb) =
		arena_img_data[(cur_plane * 1000) + a * 10 + b];
	      b++;
	      bb++;
	      (unsigned short) *(p[cur_plane] + aa * 15 + bb) =
		arena_img_data[(cur_plane * 1000) + a * 10 + b];
	      b++;
	      bb++;
	      (unsigned short) *(p[cur_plane] + aa * 15 + bb) =
		arena_img_data[(cur_plane * 1000) + a * 10 + b];
	      b++;
	      bb++;
	      (unsigned short) *(p[cur_plane] + aa * 15 + bb) =
		arena_img_data[(cur_plane * 1000) + a * 10 + b];
	      b++;
	      bb++;
	      (unsigned short) *(p[cur_plane] + aa * 15 + bb) =
		arena_img_data[(cur_plane * 1000) + a * 10 + b];
	      b++;
	      bb++;
	      (unsigned short) *(p[cur_plane] + aa * 15 + bb) =
		arena_img_data[(cur_plane * 1000) + a * 10 + b];
	      b++;
	      bb++;
	      (unsigned short) *(p[cur_plane] + aa * 15 + bb) =
		arena_img_data[(cur_plane * 1000) + a * 10 + b];
	      b++;
	      bb++;
	      (unsigned short) *(p[cur_plane] + aa * 15 + bb) =
		arena_img_data[(cur_plane * 1000) + a * 10 + b];
	      b++;
	      bb++;
	      (unsigned short) *(p[cur_plane] + aa * 15 + bb) =
		arena_img_data[(cur_plane * 1000) + a * 10 + b];
	      b++;
	      bb++;
	    }
	}

      FAT_WaitKeyPressed ();
      dissolve ();
    }
}

short
HandleMenu (FATCONFIG * fc)
{
  short a;
  PADSTATES key = 0;
#define TITLE_STRS 6
  TitleStruct title[TITLE_STRS] = {
    {5, (char *) NAME_VERSION_STRING, F_8x10},
    {18, (char *) AUTHOR_STRING, F_6x8},
    {40, (char *) "APPS for Options", F_6x8},
    {52, (char *) "ESC to exit", F_6x8},
    {64, (char *) "Any other key to start!", F_6x8},
    {94, (char *) "http://jesystems.cjb.net", F_4x6},
  };

  if (noskip)
    {
    menu:
      FAT_AllKeysReleased ();
      BlackGrayScreen ();
      for (a = 0; a < TITLE_STRS; a++)
	{
	  DrawGrayStrExt (0, title[a].y, (char *) title[a].text,
			  A_REVERSE | A_CENTERED, title[a].font);
	}

      key = FAT_GetPadState ();
      FAT_WaitKeyPressed ();
      key = FAT_GetPadState ();
      if (key & PADSTATE_APPS)
	{
	  HandleOptions ();
	  goto menu;
	}
      if (key & PADSTATE_ESC)
	return 0;
      /*while (key & PADSTATE_KA)
         key = FAT_GetPadState (); */
      else
	FAT_AllKeysReleased ();
    }
  else
    {
      key = FAT_GetPadState ();
      if (key & PADSTATE_ESC)
	return 0;
    }
  LoadExternalLevel (fc);

  return 1;
}

void
DrawHealthAndScore (void)
{
#define COUNTLENGTH 3
  short i;
  unsigned char value;
  short changed = 0;

  value = gamedata.player[REAL_PLAYER_IDX].health;
  for (i = COUNTLENGTH - 1; i >= 0; i--)
    {
      unsigned char v = value % 10;
      health.newcount[i] = v;
      value /= 10;
    }
  value = abs (gamedata.player[REAL_PLAYER_IDX].score);
  if (gamedata.player[REAL_PLAYER_IDX].score < 0)
    {
      if (gamedata.negated == 0)
	changed = 1;
      gamedata.negated = 1;
    }
  else
    {
      if (gamedata.negated == 1)
	changed = 1;
      gamedata.negated = 0;
    }

  for (i = COUNTLENGTH - 1; i >= 0; i--)
    {
      unsigned char v = value % 10;
      score.newcount[i] = v;
      value /= 10;
    }
  DrawCounter (&health);
  if (gamedata.negated)
    {
      if (changed)
	{
	  DrawGrayRect (109 + display_offsetx, 42, 140 + display_offsetx, 50,
			COLOR_BLACK, RECT_FILLED);
	  score.already_used = 0;
	}
      GraySprite8_AND (109 + display_offsetx, 43, 8, minus_spr, minus_spr,
		       GetPlane (0), GetPlane (1));
      score.x = 117 + display_offsetx;
    }
  else
    {
      if (changed)
	{
	  DrawGrayRect (109 + display_offsetx, 42, 140 + display_offsetx, 50,
			COLOR_BLACK, RECT_FILLED);
	  score.already_used = 0;
	}
      score.x = 110 + display_offsetx;
    }

  DrawCounter (&score);

}

void
ShowEndOfMatch (void)
{
  short arr[(gamedata.sprites.players + 1) * 2];
  short a;
  char temp[30];

  FAT_AllKeysReleased ();
  dissolve ();

  for (a = 0; a < gamedata.sprites.players + 1; a++)
    {
      arr[a * 2] = gamedata.player[a].score;
      arr[a * 2 + 1] = a;
    }

  bubbleSortScores (arr, gamedata.sprites.players + 1);
  if (arr[1] == REAL_PLAYER_IDX)
    {
      DrawGrayStrExt (0, 1, (char *) WON_STRING, A_REVERSE | A_CENTERED,
		      F_6x8);
    }
  else
    {
      DrawGrayStrExt (0, 1, (char *) LOST_STRING, A_REVERSE | A_CENTERED,
		      F_6x8);
    }
  if (gamedata.gametype != DM)
    {
      sprintf (temp, "Gray %i, White %i", gamedata.team[GRAY_TEAM].score,
	       gamedata.team[WHITE_TEAM].score);
      DrawGrayStrExt (0, 10, temp, A_REVERSE | A_CENTERED, F_6x8);
    }
  DrawGrayStrExt (21 + display_offsetx, 19 + display_offsety,
		  (char *) "Player  |Team|  Score", A_REVERSE | A_CENTERED,
		  F_6x8);
  for (a = 0; a < gamedata.sprites.players + 1; a++)
    {
      if (arr[a * 2 + 1] == REAL_PLAYER_IDX)
	sprintf (temp, "%s |%s| %i", gamedata.cfg.name,
		 gamedata.player[arr[a * 2 + 1]].team ? "W" : "G",
		 arr[a * 2]);

      else
	sprintf (temp, "Bot #%i   |%s| %i", arr[a * 2 + 1],
		 gamedata.player[arr[a * 2 + 1]].team ? "W" : "G",
		 arr[a * 2]);

      DrawGrayStrExt (32 + display_offsetx, 29 + a * 11 + display_offsety,
		      temp, A_REVERSE, F_6x8);
    }

  DrawGrayStrExt (0, 90, (char *) "Wait...", A_REVERSE | A_CENTERED, F_6x8);
  int5_counter = 0;
  while (int5_counter < 80);
  DrawGrayStrExt (0, 90, (char *) "Press a Key", A_REVERSE | A_CENTERED,
		  F_6x8);
  FAT_WaitKeyPressed ();

  dissolve ();

  FAT_AllKeysReleased ();

}


void
DisplayCurrentScores (void)
{
  short arr[(gamedata.sprites.players + 1) * 2];
  short a;
  char temp[30];
  PADSTATES key = 0;

  DrawGrayRect (0 + display_offsetx, 2 + display_offsety,
		95 + display_offsetx, 97 + display_offsety, COLOR_BLACK,
		RECT_FILLED);

  for (a = 0; a < gamedata.sprites.players + 1; a++)
    {
      arr[a * 2] = gamedata.player[a].score;
      arr[a * 2 + 1] = a;
    }

  bubbleSortScores (arr, gamedata.sprites.players + 1);
  //DrawGrayStrExt (20 + display_offsetx, 3 + display_offsety,
  //        (char *)   "SCORES", A_REVERSE, F_6x8);
  if (gamedata.gametype != DM)
    {
      sprintf (temp, "Gray %i, White %i", gamedata.team[GRAY_TEAM].score,
	       gamedata.team[WHITE_TEAM].score);
      DrawGrayStrExt (0, 3, temp, A_REVERSE, F_6x8);
    }
  DrawGrayStrExt (21 + display_offsetx, 13 + display_offsety,
		  (char *) "Player |Team| Score", A_REVERSE, F_4x6);
  for (a = 0; a < gamedata.sprites.players + 1; a++)
    {
      if (arr[a * 2 + 1] == REAL_PLAYER_IDX)
	sprintf (temp, "%s |%s| %i", gamedata.cfg.name,
		 gamedata.player[arr[a * 2 + 1]].team ? "W" : "G",
		 arr[a * 2]);

      else
	sprintf (temp, "Bot #%i   |%s| %i", arr[a * 2 + 1],
		 gamedata.player[arr[a * 2 + 1]].team ? "W" : "G",
		 arr[a * 2]);

      DrawGrayStrExt (2 + display_offsetx, 20 + a * 11 + display_offsety,
		      temp, A_REVERSE, F_6x8);
    }

  key = FAT_GetPadState ();
  while (key & PADSTATE_APPS)
    key = FAT_GetPadState ();

}

#define NEW_COMPASS_CODE
#ifdef OLD_COMPASS_CODE
void
DrawCompass (FATCONFIG * fc)
{
  short newx =
    COMPASS_X + display_offsetx +
    (((long) FAT_Cos16384 (fc->cam_orientation) * COMPASS_RADIUS) >> 14);
  short newy =
    COMPASS_Y + display_offsety +
    (((long) FAT_Sin16384 (fc->cam_orientation) * COMPASS_RADIUS) >> 14);
  short newx2 =
    COMPASS_X + display_offsetx +
    (((long) FAT_Cos16384 (gamedata.player[0].last_hit_dir) *
      COMPASS_LASTHIT_RADIUS) >> 14);
  short newy2 =
    COMPASS_Y + display_offsety +
    (((long) FAT_Sin16384 (gamedata.player[0].last_hit_dir) *
      COMPASS_LASTHIT_RADIUS) >> 14);

//Erase old
  GraySprite32_AND (COMPASS_X_LEFT + display_offsetx,
		    COMPASS_Y_TOP + display_offsety, 32, compass_spr,
		    compass_spr + 32, GetPlane (0), GetPlane (1));
//Draw new      
  FastDrawGrayLine (COMPASS_X + display_offsetx, COMPASS_Y + display_offsety,
		    newx, newy, COLOR_BLACK);
  FastDrawGrayLine (COMPASS_X + display_offsetx, COMPASS_Y + display_offsety,
		    newx2, newy2, COLOR_BLACK);
}
#endif
#ifdef NEW_COMPASS_CODE
void
DrawCompass (FATCONFIG * fc)
{
  if (!gamedata.cfg.radar)
    return;

  short newx =
    COMPASS_X + display_offsetx +
    (((long) FAT_Cos16384 (gamedata.player[0].last_hit_dir) *
      COMPASS_LASTHIT_RADIUS) >> 14);
  short newy =
    COMPASS_Y + display_offsety +
    (((long) FAT_Sin16384 (gamedata.player[0].last_hit_dir) *
      COMPASS_LASTHIT_RADIUS) >> 14);

//get current angles...
#define COMPASS_DISTANCE 512	//64 is one tile
#define COMPASS_MAX 16
#define COMPASS_ADJUST 5	//2 ^ COMPASS_ADJUST must == (COMPASS_DISTANCE/COMPASS_MAX)
#if (COMPASS_DISTANCE/(1<<COMPASS_ADJUST) != COMPASS_MAX)
#error Check your math in COMPASS_ADJUST :-)
#endif
  long orientation_x = (long) FAT_Cos16384 (fc->cam_orientation);
  long orientation_y = (long) FAT_Sin16384 (fc->cam_orientation);

  short north_x1 =
    COMPASS_X + display_offsetx + ((orientation_x * COMPASS_RADIUS) >> 14);
  short north_y1 =
    COMPASS_Y + display_offsety + ((orientation_y * COMPASS_RADIUS) >> 14);
  short north_x2 =
    COMPASS_X + display_offsetx +
    ((orientation_x * (COMPASS_RADIUS + 2)) >> 14);
  short north_y2 =
    COMPASS_Y + display_offsety +
    ((orientation_y * (COMPASS_RADIUS + 2)) >> 14);
  unsigned long bot_dist;
  long dist_squared;
  short bot_x_dist, bot_y_dist, bot_x, bot_y, botN;

//Erase old
  GraySprite32_AND (COMPASS_X_LEFT + display_offsetx,
		    COMPASS_Y_TOP + display_offsety, 32, compass_spr,
		    compass_spr + 32, GetPlane (0), GetPlane (1));
//Draw the lines
  FastDrawGrayLine (north_x1, north_y1, north_x2, north_y2, COLOR_DARKGRAY);
  FastDrawGrayLine (COMPASS_X + display_offsetx, COMPASS_Y + display_offsety,
		    newx, newy, COLOR_DARKGRAY);
  //EXT_SETPIX( GetPlane (1) , COMPASS_X + display_offsetx , COMPASS_Y + display_offsety );

  for (botN = 1; botN <= gamedata.sprites.players; botN++)
    {
/*
Relative = in relation to the player.

For each bot, find the relative distance and location.
This means if bot1 is at (140,40) and player is at (140,78),
the relative location is (0,-38).
*/


      bot_x_dist =
	gamedata.player[botN].spr->xpos - gamedata.player[0].spr->xpos;
      bot_y_dist =
	gamedata.player[botN].spr->ypos - gamedata.player[0].spr->ypos;
      dist_squared =
	(long) (squared (bot_x_dist)) + (long) (squared (bot_y_dist));
      bot_dist = FAT_FastSqrt (dist_squared);
      if (bot_dist > (unsigned long) COMPASS_DISTANCE)
	continue;
/*
Zero out the coordinates: COMPASS_X + display_offsetx is x = 0 on the radar, same with y
*/
      bot_x = COMPASS_X + display_offsetx + (bot_x_dist >> COMPASS_ADJUST);
      bot_y = COMPASS_Y + display_offsety + (bot_y_dist >> COMPASS_ADJUST);
//We want this on the dark plane, for a dark gray dot.
      EXT_SETPIX (GetPlane (DARK_PLANE), bot_x, bot_y);
    }
}
#endif

void
DrawMultiplier (void)
{
  short x0 = MULTIPLIER_X + MAX_MULTIPLIER * MULTIPLIER_WIDTH;
  short x1 =
    MULTIPLIER_X + gamedata.player[0].rocket_multiplier * MULTIPLIER_WIDTH;
  if (gamedata.player[0].rocket_multiplier < MAX_MULTIPLIER)
    {
      DrawGrayRect (x1, MULTIPLIER_Y, x0 - 1,
		    MULTIPLIER_Y + MULTIPLIER_HEIGHT, COLOR_WHITE,
		    RECT_FILLED);
    }
  if (gamedata.player[0].rocket_multiplier)
    {
      DrawGrayRect (MULTIPLIER_X, MULTIPLIER_Y, x1 - 1,
		    MULTIPLIER_Y + MULTIPLIER_HEIGHT, COLOR_DARKGRAY,
		    RECT_FILLED);

    }

}
